Create redemption - Fabric
Create redemption
cURL
curl --request POST \
--url https://live.copilot.fabric.inc/api-offers/redemption \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--header 'x-site-context: <x-site-context>' \
--data '
{
"promoId": "614b58924e92f6861ac91234",
"orderId": "1590-2016-12345",
"promoCode": "BESTSUMMER",
"userId": "614b58924e92f61234567890",
"email": "john.doe@gmail.com"
}
'```
### Python
```python
import requests
url = "https://live.copilot.fabric.inc/api-offers/redemption"
payload = {
"promoId": "614b58924e92f6861ac91234",
"orderId": "1590-2016-12345",
"promoCode": "BESTSUMMER",
"userId": "614b58924e92f61234567890",
"email": "john.doe@gmail.com"
}
headers = {
"x-site-context": "<x-site-context>",
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)
JavaScript (Fetch API)
const options = {
method: 'POST',
headers: {
'x-site-context': '<x-site-context>',
Authorization: 'Bearer <token>',
'Content-Type': 'application/json'
},
body: JSON.stringify({
promoId: '614b58924e92f6861ac91234',
orderId: '1590-2016-12345',
promoCode: 'BESTSUMMER',
userId: '614b58924e92f61234567890',
email: 'john.doe@gmail.com'
})
};
fetch('https://live.copilot.fabric.inc/api-offers/redemption', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));
PHP
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://live.copilot.fabric.inc/api-offers/redemption",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'promoId' => '614b58924e92f6861ac91234',
'orderId' => '1590-2016-12345',
'promoCode' => 'BESTSUMMER',
'userId' => '614b58924e92f61234567890',
'email' => 'john.doe@gmail.com'
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json",
"x-site-context: <x-site-context>"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}
Go
package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://live.copilot.fabric.inc/api-offers/redemption"
payload := strings.NewReader("{\n \"promoId\": \"614b58924e92f6861ac91234\",\n \"orderId\": \"1590-2016-12345\",\n \"promoCode\": \"BESTSUMMER\",\n \"userId\": \"614b58924e92f61234567890\",\n \"email\": \"john.doe@gmail.com\"\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("x-site-context", "<x-site-context>")
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}
Response Format
Success Response
{
"_id": "614b58924e92f6861ac9d43b",
"promoId": "614b58924e92f6861ac91234",
"promoCode": "BESTSUMMER",
"userId": "614b58924e92f61234567890",
"email": "guest@gmail.com",
"orderId": "1590-2016-12345",
"createdAt": "2020-12-14T12:15:43.646Z",
"updatedAt": "2021-12-14T12:15:43.646Z"
}
Error Response
{
"code": "BAD_REQUEST",
"message": "Bad Request"
}
{
"code": "INTERNAL_SERVER_ERROR",
"message": "Internal server error."
}
Authorization
- Authorization:
Bearer <token>(required)
Headers
- x-site-context: (required)
Example: {"date": "2023-01-01T00:00:00.000Z", "channel": 12, "account": "1234abcd5678efgh9ijklmno", "stage":"production"}
Body
- promoId (string, required): Fabric database objectId of the promotion to redeem.
- orderId (string, required): Order ID of this purchase.
- promoCode (string | null): Coupon code to be redeemed.
- userId (string | null): ID of the user redeeming.
- email (string): Email address of the user redeeming.